(function(global2, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2.utils = {}));
})(this, function(exports2) {
  "use strict";var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

  var it = Object.defineProperty;
  var ct = (r, t, e) => t in r ? it(r, t, { enumerable: true, configurable: true, writable: true, value: e }) : r[t] = e;
  var c = (r, t, e) => ct(r, typeof t != "symbol" ? t + "" : t, e);
  function ut(r, t = false) {
    if (r == null) throw new Error("Cannot clean a NULL value");
    return Array.isArray(r) ? r = r.filter((e) => e != null) : Object.entries(r).forEach(([e, n]) => {
      (t && n === void 0 || !t && n == null) && delete r[e];
    }), r;
  }
  function A(r, t) {
    const e = typeof r, n = typeof t;
    return e != "object" || r == null || n != "object" || t == null ? e == "function" && n == "function" ? r.toString() == t.toString() : r === t : Object.keys(r).length != Object.keys(t).length ? false : Object.keys(r).every((o) => A(r[o], t[o]));
  }
  function M(r) {
    try {
      return JSON.parse(r);
    } catch {
      return r;
    }
  }
  function Lt(r, t) {
    let e = [];
    return JSON.stringify(r, (n, s) => {
      if (typeof s == "object" && s !== null) {
        if (e.includes(s)) return;
        e.push(s);
      }
      return s;
    }, t);
  }
  function ft(r) {
    return Array.isArray(r) ? r : [r];
  }
  class Dt {
    /**
     * Create new cache
     *
     * @param {keyof T} key Default property to use as primary key
     * @param {number} ttl Default expiry in milliseconds
     */
    constructor(t, e) {
      c(this, "store", {});
      c(this, "complete", false);
      c(this, "values", this.all());
      return this.key = t, this.ttl = e, new Proxy(this, {
        get: (n, s) => s in n ? n[s] : n.store[s],
        set: (n, s, o) => (s in n ? n[s] = o : n.store[s] = o, true)
      });
    }
    getKey(t) {
      if (!this.key) throw new Error("No key defined");
      return t[this.key];
    }
    /**
     * Get all cached items
     *
     * @return {T[]} Array of items
     */
    all() {
      return Object.values(this.store);
    }
    /**
     * Add a new item to the cache. Like set, but finds key automatically
     *
     * @param {T} value Item to add to cache
     * @param {number | undefined} ttl Override default expiry
     * @return {this}
     */
    add(t, e = this.ttl) {
      const n = this.getKey(t);
      return this.set(n, t, e), this;
    }
    /**
     * Add several rows to the cache
     *
     * @param {T[]} rows Several items that will be cached using the default key
     * @param complete Mark cache as complete & reliable, defaults to true
     * @return {this}
     */
    addAll(t, e = true) {
      return t.forEach((n) => this.add(n)), this.complete = e, this;
    }
    /**
     * Delete an item from the cache
     *
     * @param {K} key Item's primary key
     */
    delete(t) {
      delete this.store[t];
    }
    /**
     * Return cache as an array of key-value pairs
     * @return {[K, T][]} Key-value pairs array
     */
    entries() {
      return Object.entries(this.store);
    }
    /**
     * Get item from the cache
     * @param {K} key Key to lookup
     * @return {T} Cached item
     */
    get(t) {
      return this.store[t];
    }
    /**
     * Get a list of cached keys
     *
     * @return {K[]} Array of keys
     */
    keys() {
      return Object.keys(this.store);
    }
    /**
     * Get map of cached items
     *
     * @return {Record<K, T>}
     */
    map() {
      return structuredClone(this.store);
    }
    /**
     * Add an item to the cache manually specifying the key
     *
     * @param {K} key Key item will be cached under
     * @param {T} value Item to cache
     * @param {number | undefined} ttl Override default expiry
     * @return {this}
     */
    set(t, e, n = this.ttl) {
      return this.store[t] = e, n && setTimeout(() => {
        this.complete = false, this.delete(t);
      }, n), this;
    }
  }
  class E extends Promise {
    constructor(e) {
      super((n, s) => e(
        (o) => n(o),
        (o) => s(o),
        (o) => this.progress = o
      ));
      c(this, "listeners", []);
      c(this, "_progress", 0);
    }
    get progress() {
      return this._progress;
    }
    set progress(e) {
      e != this._progress && (this._progress = e, this.listeners.forEach((n) => n(e)));
    }
    static from(e) {
      return e instanceof E ? e : new E((n, s) => e.then((...o) => n(...o)).catch((...o) => s(...o)));
    }
    from(e) {
      const n = E.from(e);
      return this.onProgress((s) => n.progress = s), n;
    }
    onProgress(e) {
      return this.listeners.push(e), this;
    }
    then(e, n) {
      const s = super.then(e, n);
      return this.from(s);
    }
    catch(e) {
      return this.from(super.catch(e));
    }
    finally(e) {
      return this.from(super.finally(e));
    }
  }
  function Gt(r, t) {
    r instanceof Blob || (r = new Blob(ft(r)));
    const e = URL.createObjectURL(r);
    dt(e, t), URL.revokeObjectURL(e);
  }
  function dt(r, t) {
    const e = document.createElement("a");
    e.href = r, e.download = t || r.split("/").pop(), document.body.appendChild(e), e.click(), document.body.removeChild(e);
  }
  function Ut(r = {}) {
    return new Promise((t) => {
      const e = document.createElement("input");
      e.type = "file", e.accept = r.accept || "*", e.style.display = "none", e.multiple = !!r.multiple, e.onblur = e.onchange = async () => {
        t(Array.from(e.files)), e.remove();
      }, document.body.appendChild(e), e.click();
    });
  }
  function Ft(r) {
    return new E((t, e, n) => {
      const s = new XMLHttpRequest(), o = new FormData();
      r.files.forEach((i) => o.append("file", i)), s.withCredentials = !!r.withCredentials, s.upload.addEventListener("progress", (i) => i.lengthComputable ? n(i.loaded / i.total) : null), s.addEventListener("loadend", () => t(M(s.responseText))), s.addEventListener("error", () => e(M(s.responseText))), s.addEventListener("timeout", () => e({ error: "Request timed out" })), s.open("POST", r.url), Object.entries(r.headers || {}).forEach(([i, a]) => s.setRequestHeader(i, a)), s.send(o);
    });
  }
  class _ {
    constructor() {
      c(this, "listeners", {});
    }
    static emit(t, ...e) {
      (this.listeners["*"] || []).forEach((n) => n(t, ...e)), (this.listeners[t.toString()] || []).forEach((n) => n(...e));
    }
    static off(t, e) {
      const n = t.toString();
      this.listeners[n] = (this.listeners[n] || []).filter((s) => s === e);
    }
    static on(t, e) {
      var s;
      const n = t.toString();
      return this.listeners[n] || (this.listeners[n] = []), (s = this.listeners[n]) == null || s.push(e), () => this.off(t, e);
    }
    static once(t, e) {
      return new Promise((n) => {
        const s = this.on(t, (...o) => {
          n(o.length == 1 ? o[0] : o), e && e(...o), s();
        });
      });
    }
    emit(t, ...e) {
      (this.listeners["*"] || []).forEach((n) => n(t, ...e)), (this.listeners[t] || []).forEach((n) => n(...e));
    }
    off(t, e) {
      this.listeners[t] = (this.listeners[t] || []).filter((n) => n === e);
    }
    on(t, e) {
      var n;
      return this.listeners[t] || (this.listeners[t] = []), (n = this.listeners[t]) == null || n.push(e), () => this.off(t, e);
    }
    once(t, e) {
      return new Promise((n) => {
        const s = this.on(t, (...o) => {
          n(o.length == 1 ? o[0] : o), e && e(...o), s();
        });
      });
    }
  }
  c(_, "listeners", {});
  class p extends Error {
    constructor(e, n) {
      super(e);
      c(this, "_code");
      n != null && (this._code = n);
    }
    get code() {
      return this._code || this.constructor.code;
    }
    set code(e) {
      this._code = e;
    }
    static from(e) {
      const n = Number(e.statusCode) ?? Number(e.code), s = new this(e.message || e.toString());
      return Object.assign(s, {
        stack: e.stack,
        ...e,
        code: n ?? void 0
      });
    }
    static instanceof(e) {
      return e.constructor.code != null;
    }
    toString() {
      return this.message || super.toString();
    }
  }
  c(p, "code", 500);
  class W extends p {
    constructor(t = "Bad Request") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(W, "code", 400);
  class J extends p {
    constructor(t = "Unauthorized") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(J, "code", 401);
  class z extends p {
    constructor(t = "Payment Required") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(z, "code", 402);
  class K extends p {
    constructor(t = "Forbidden") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(K, "code", 403);
  class Z extends p {
    constructor(t = "Not Found") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(Z, "code", 404);
  class V extends p {
    constructor(t = "Method Not Allowed") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(V, "code", 405);
  class X extends p {
    constructor(t = "Not Acceptable") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(X, "code", 406);
  class Q extends p {
    constructor(t = "Internal Server Error") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(Q, "code", 500);
  class tt extends p {
    constructor(t = "Not Implemented") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(tt, "code", 501);
  class et extends p {
    constructor(t = "Bad Gateway") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(et, "code", 502);
  class rt extends p {
    constructor(t = "Service Unavailable") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(rt, "code", 503);
  class nt extends p {
    constructor(t = "Gateway Timeout") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(nt, "code", 504);
  const w = class w2 {
    constructor(t = {}) {
      c(this, "interceptors", {});
      c(this, "headers", {});
      c(this, "url");
      this.url = t.url ?? null, this.headers = t.headers || {}, t.interceptors && t.interceptors.forEach((e) => w2.addInterceptor(e));
    }
    static addInterceptor(t) {
      const e = Object.keys(w2.interceptors).length.toString();
      return w2.interceptors[e] = t, () => {
        w2.interceptors[e] = null;
      };
    }
    addInterceptor(t) {
      const e = Object.keys(this.interceptors).length.toString();
      return this.interceptors[e] = t, () => {
        this.interceptors[e] = null;
      };
    }
    request(t = {}) {
      var s;
      if (!this.url && !t.url) throw new Error("URL needs to be set");
      let e = ((s = t.url) != null && s.startsWith("http") ? t.url : (this.url || "") + (t.url || "")).replace(/([^:]\/)\/+/g, "$1");
      if (t.fragment && (e.includes("#") ? e.replace(/#.*(\?|\n)/g, (o, i) => `#${t.fragment}${i}`) : e += "#" + t.fragment), t.query) {
        const o = Array.isArray(t.query) ? t.query : Object.keys(t.query).map((i) => ({ key: i, value: t.query[i] }));
        e += (e.includes("?") ? "&" : "?") + o.map((i) => `${i.key}=${i.value}`).join("&");
      }
      const n = ut({
        "Content-Type": t.body ? t.body instanceof FormData ? "multipart/form-data" : "application/json" : void 0,
        ...w2.headers,
        ...this.headers,
        ...t.headers
      });
      return typeof t.body == "object" && t.body != null && n["Content-Type"] == "application/json" && (t.body = JSON.stringify(t.body)), new E((o, i, a) => {
        fetch(e, {
          headers: n,
          method: t.method || (t.body ? "POST" : "GET"),
          body: t.body
        }).then(async (u) => {
          var G, U;
          for (let l of [...Object.values(w2.interceptors), ...Object.values(this.interceptors)])
            await new Promise((R) => l(u, () => R()));
          const v = u.headers.get("Content-Length"), N = v ? parseInt(v, 10) : 0;
          let P = 0;
          const I = (G = u.body) == null ? void 0 : G.getReader(), ot = new ReadableStream({
            start(l) {
              function R() {
                I == null || I.read().then((O) => {
                  if (O.done) return l.close();
                  P += O.value.byteLength, a(P / N), l.enqueue(O.value), R();
                }).catch((O) => l.error(O));
              }
              R();
            }
          });
          if (u.data = new Response(ot), t.decode == null || t.decode) {
            const l = (U = u.headers.get("Content-Type")) == null ? void 0 : U.toLowerCase();
            l != null && l.includes("form") ? u.data = await u.data.formData() : l != null && l.includes("json") ? u.data = await u.data.json() : l != null && l.includes("text") ? u.data = await u.data.text() : l != null && l.includes("application") && (u.data = await u.data.blob());
          }
          u.ok ? o(u) : i(u);
        });
      });
    }
  };
  c(w, "interceptors", {}), c(w, "headers", {});
  let F = w;
  const x = {
    CLEAR: "\x1B[0m",
    BRIGHT: "\x1B[1m",
    DIM: "\x1B[2m",
    UNDERSCORE: "\x1B[4m",
    BLINK: "\x1B[5m",
    REVERSE: "\x1B[7m",
    HIDDEN: "\x1B[8m"
  }, j = {
    BLACK: "\x1B[30m",
    RED: "\x1B[31m",
    GREEN: "\x1B[32m",
    YELLOW: "\x1B[33m",
    BLUE: "\x1B[34m",
    MAGENTA: "\x1B[35m",
    CYAN: "\x1B[36m",
    LIGHT_GREY: "\x1B[37m",
    GREY: "\x1B[90m",
    LIGHT_RED: "\x1B[91m",
    LIGHT_GREEN: "\x1B[92m",
    LIGHT_YELLOW: "\x1B[93m",
    LIGHT_BLUE: "\x1B[94m",
    LIGHT_MAGENTA: "\x1B[95m",
    LIGHT_CYAN: "\x1B[96m",
    WHITE: "\x1B[97m"
  };
  var yt = /* @__PURE__ */ ((r) => (r[r.ERROR = 0] = "ERROR", r[r.WARN = 1] = "WARN", r[r.INFO = 2] = "INFO", r[r.LOG = 3] = "LOG", r[r.DEBUG = 4] = "DEBUG", r))(yt || {});
  const g = class g2 extends _ {
    constructor(t) {
      super(), this.namespace = t;
    }
    pad(t, e, n, s = false) {
      const o = t.toString(), i = e - o.length;
      if (i <= 0) return o;
      const a = Array(~~(i / n.length)).fill(n).join("");
      return s ? o + a : a + o;
    }
    format(...t) {
      const e = /* @__PURE__ */ new Date();
      return `${`${e.getFullYear()}-${e.getMonth() + 1}-${e.getDate()} ${this.pad(e.getHours().toString(), 2, "0")}:${this.pad(e.getMinutes().toString(), 2, "0")}:${this.pad(e.getSeconds().toString(), 2, "0")}.${this.pad(e.getMilliseconds().toString(), 3, "0", true)}`}${this.namespace ? ` [${this.namespace}]` : ""} ${t.join(" ")}`;
    }
    debug(...t) {
      if (g2.LOG_LEVEL < 4) return;
      const e = this.format(...t);
      g2.emit(4, e), console.debug(j.LIGHT_GREY + e + x.CLEAR);
    }
    log(...t) {
      if (g2.LOG_LEVEL < 3) return;
      const e = this.format(...t);
      g2.emit(3, e), console.log(x.CLEAR + e);
    }
    info(...t) {
      if (g2.LOG_LEVEL < 2) return;
      const e = this.format(...t);
      g2.emit(2, e), console.info(j.BLUE + e + x.CLEAR);
    }
    warn(...t) {
      if (g2.LOG_LEVEL < 1) return;
      const e = this.format(...t);
      g2.emit(1, e), console.warn(j.YELLOW + e + x.CLEAR);
    }
    error(...t) {
      if (g2.LOG_LEVEL < 0) return;
      const e = this.format(...t);
      g2.emit(0, e), console.error(j.RED + e + x.CLEAR);
    }
  };
  c(g, "LOG_LEVEL", 4);
  var $ = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, xt = {}, S = {};
  Object.defineProperty(S, "__esModule", { value: true });
  S.persist = S.Persist = void 0;
  class st {
    /**
     * @param {string} key Primary key value will be stored under
     * @param {PersistOptions<T>} options Configure using {@link PersistOptions}
     */
    constructor(t, e = {}) {
      c(this, "key");
      c(this, "options");
      c(this, "storage");
      c(this, "watches", {});
      c(this, "_value");
      this.key = t, this.options = e, this.storage = e.storage || localStorage, this.load();
    }
    /** Current value or default if undefined */
    get value() {
      var t;
      return this._value !== void 0 ? this._value : (t = this.options) == null ? void 0 : t.default;
    }
    /** Set value with proxy object wrapper to sync future changes */
    set value(t) {
      t == null || typeof t != "object" ? this._value = t : this._value = new Proxy(t, {
        get: (e, n) => typeof e[n] == "function" ? (...o) => {
          const i = e[n](...o);
          return this.save(), i;
        } : e[n],
        set: (e, n, s) => (e[n] = s, this.save(), true)
      }), this.save();
    }
    /** Notify listeners of change */
    notify(t) {
      Object.values(this.watches).forEach((e) => e(t));
    }
    /** Delete value from storage */
    clear() {
      this.storage.removeItem(this.key);
    }
    /** Save current value to storage */
    save() {
      this._value === void 0 ? this.clear() : this.storage.setItem(this.key, JSON.stringify(this._value)), this.notify(this.value);
    }
    /** Load value from storage */
    load() {
      if (this.storage[this.key] != null) {
        let t = JSON.parse(this.storage.getItem(this.key));
        t != null && typeof t == "object" && this.options.type && (t.__proto__ = this.options.type.prototype), this.value = t;
      } else
        this.value = this.options.default || void 0;
    }
    /**
     * Callback function which is run when there are changes
     *
     * @param {(value: T) => any} fn Callback will run on each change; it's passed the next value & it's return is ignored
     * @returns {() => void} Function which will unsubscribe the watch/callback when called
     */
    watch(t) {
      const e = Object.keys(this.watches).length;
      return this.watches[e] = t, () => {
        delete this.watches[e];
      };
    }
    /**
     * Return value as JSON string
     *
     * @returns {string} Stringified object as JSON
     */
    toString() {
      return JSON.stringify(this.value);
    }
    /**
     * Return current value
     *
     * @returns {T} Current value
     */
    valueOf() {
      return this.value;
    }
  }
  S.Persist = st;
  function Bt(r) {
    return (t, e) => {
      const n = (r == null ? void 0 : r.key) || `${t.constructor.name}.${e.toString()}`, s = new st(n, r);
      Object.defineProperty(t, e, {
        get: function() {
          return s.value;
        },
        set: function(o) {
          s.value = o;
        }
      });
    };
  }
  S.persist = Bt;
  var L = {};
  Object.defineProperty(L, "__esModule", { value: true });
  L.MemoryStorage = void 0;
  class At {
    get length() {
      return Object.keys(this).length;
    }
    clear() {
      Object.keys(this).forEach((t) => this.removeItem(t));
    }
    getItem(t) {
      return this[t];
    }
    key(t) {
      return Object.keys(this)[t];
    }
    removeItem(t) {
      delete this[t];
    }
    setItem(t, e) {
      this[t] = e;
    }
  }
  L.MemoryStorage = At;
  (function(r) {
    var t = $ && $.__createBinding || (Object.create ? function(n, s, o, i) {
      i === void 0 && (i = o);
      var a = Object.getOwnPropertyDescriptor(s, o);
      (!a || ("get" in a ? !s.__esModule : a.writable || a.configurable)) && (a = { enumerable: true, get: function() {
        return s[o];
      } }), Object.defineProperty(n, i, a);
    } : function(n, s, o, i) {
      i === void 0 && (i = o), n[i] = s[o];
    }), e = $ && $.__exportStar || function(n, s) {
      for (var o in n) o !== "default" && !Object.prototype.hasOwnProperty.call(s, o) && t(s, n, o);
    };
    Object.defineProperty(r, "__esModule", { value: true }), e(S, r), e(L, r);
  })(xt);
  class Api extends F {
    constructor(url = location.origin, opts = {}) {
      opts.url = url;
      super(opts);
      __publicField(this, "emitter", new _());
      __publicField(this, "pending", {});
      __publicField(this, "_token", null);
      __publicField(this, "emit", this.emitter.emit.bind(this.emitter));
      __publicField(this, "off", this.emitter.off.bind(this.emitter));
      __publicField(this, "on", this.emitter.on.bind(this.emitter));
      __publicField(this, "once", this.emitter.once.bind(this.emitter));
      this.url = url;
      this.opts = opts;
    }
    get token() {
      return this._token;
    }
    set token(token) {
      if (token == this._token) return;
      this._token = token;
      this.headers["Authorization"] = token ? `Bearer ${token}` : null;
      this.emit("token", token);
    }
    healthcheck() {
      return this.request({ url: "/api/healthcheck" });
    }
    path(...children) {
      return children.filter((p2) => !!p2).join("/").replaceAll("//", "/");
    }
    request(options) {
      const key = Lt(options);
      if (this.pending[key] != null) return this.pending[key];
      this.pending[key] = super.request(options).then((resp) => {
        this.emit("response", resp, options);
        return resp.data;
      }).catch((err) => {
        const e = (err == null ? void 0 : err.data) || err;
        this.emit("rejected", e, options);
        throw e;
      }).finally(() => delete this.pending[key]);
      this.emit("request", this.pending[key], options);
      return this.pending[key];
    }
  }
  var ActionType = /* @__PURE__ */ ((ActionType2) => {
    ActionType2[ActionType2["CRON"] = 0] = "CRON";
    ActionType2[ActionType2["EVENT"] = 1] = "EVENT";
    ActionType2[ActionType2["DELETE"] = 2] = "DELETE";
    ActionType2[ActionType2["GET"] = 3] = "GET";
    ActionType2[ActionType2["PATCH"] = 4] = "PATCH";
    ActionType2[ActionType2["POST"] = 5] = "POST";
    ActionType2[ActionType2["PUT"] = 6] = "PUT";
    return ActionType2;
  })(ActionType || {});
  class Actions extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Dt("_id"));
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    delete(id) {
      return this.api.request({ url: `/api/actions/${id}`, method: "DELETE" }).then(() => {
        this.cache.delete(id);
        this.emit("delete", id);
      });
    }
    all() {
      return this.api.request({ url: `/api/actions` }).then((resp) => {
        this.cache.addAll(resp);
        this.emit("all", resp || []);
        return resp;
      });
    }
    read(id, reload = false) {
      const cached = this.cache.get(id);
      if (!reload && cached) return Promise.resolve(cached);
      return this.api.request({ url: `/api/actions/${id}` }).then((action) => {
        if (action) this.cache.add(action);
        this.emit("read", action);
        return action;
      });
    }
    run(path, opts = {}) {
      return this.api.request({ url: (`/api/actions/run/` + path).replaceAll("//", "/"), ...opts }).then((resp) => {
        this.emit("execute", path, resp);
        return resp;
      });
    }
    runById(action, opts = {}) {
      const id = typeof action == "string" ? action : action._id;
      return this.api.request({ url: "/api/actions/run-by-id/" + id, method: "POST", ...opts }).then((resp) => {
        this.emit("execute", typeof action == "string" ? action : action._id, resp);
        return resp;
      });
    }
    update(action) {
      return this.api.request({
        url: `/api/actions${action._id ? `/${action._id}` : ""}`,
        method: "POST",
        body: action
      }).then((action2) => {
        if (action2) this.cache.add(action2);
        this.emit("update", action2);
        return action2;
      });
    }
  }
  class Ai extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    ask(question, context) {
      return this.api.request({ url: `/api/ai`, method: "POST", body: {
        question,
        context
      } }).then((resp) => {
        this.emit("ask", question, context, resp);
        return resp;
      });
    }
    clear() {
      return this.api.request({ url: "/api/ai", method: "DELETE" });
    }
  }
  class Analytics extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    ipTrace(ip) {
      return this.api.request({ url: `/api/analytics/trace?ip=${ip}` }).then((resp) => {
        this.emit("ipTrace", ip, resp);
        return resp;
      });
    }
  }
  class Totp {
    constructor(api) {
      __publicField(this, "enable", this.reset);
      this.api = api;
    }
    disable(username) {
      return this.api.request({ url: `/api/auth/totp/${username}`, method: "DELETE" });
    }
    reset(username) {
      return this.api.request({ url: `/api/auth/totp/${username}`, method: "POST" });
    }
    setup(username, method = "app", totp) {
      return this.api.request({ url: `/api/auth/totp/${username}`, body: ut({
        method,
        totp
      }) });
    }
  }
  class Auth extends _ {
    constructor(api, opts = {}) {
      super();
      __publicField(this, "api");
      __publicField(this, "storageKey");
      __publicField(this, "totp");
      __publicField(this, "_user");
      this.opts = opts;
      this.api = typeof api == "string" ? new Api(api) : api;
      this.totp = new Totp(this.api);
      this.opts = {
        loginUi: this.api.url + "/ui/#/login",
        persist: true,
        ...this.opts
      };
      this.storageKey = `momentum:${new URL(this.api.url).host}`;
      this.api.addInterceptor((resp, next) => {
        const blacklist = [
          "/api/auth/login",
          "/api/auth/password",
          "/api/auth/totp"
        ];
        if (resp.status == 401 && !blacklist.find((url) => resp.url.includes(url)))
          this.emit("sessionExpired");
        next();
      });
      this.api.on("token", (token) => {
        var _a;
        if ((_a = this.opts) == null ? void 0 : _a.persist) {
          if (token) localStorage.setItem(this.storageKey, token);
          else localStorage.removeItem(this.storageKey);
        }
        if (token) this.session(token, true).catch(() => {
        });
        else this.user = null;
      });
      if (opts == null ? void 0 : opts.persist) {
        const token = localStorage.getItem(this.storageKey);
        if (token) this.api.token = token;
        else this.user = null;
      } else {
        this.user = null;
      }
    }
    get user() {
      return this._user;
    }
    set user(user) {
      if (!A(this.user, user)) {
        this._user = user ? user : null;
        this.emit("user", this._user);
      }
    }
    knownHost(host = location.origin) {
      if (host.startsWith("/")) return Promise.resolve();
      return this.api.request({ url: `/api/auth/known-host?host=${encodeURI(new URL(host).origin)}` }).then(() => {
      });
    }
    login(username, password, totp) {
      return this.api.request({
        url: "/api/auth/login",
        headers: { Authorization: void 0 },
        method: "POST",
        body: {
          username: username.trim(),
          password: password.trim(),
          totp
        }
      }).then(async (resp) => {
        this.api.token = (resp == null ? void 0 : resp.token) || null;
        const user = await this.once("user");
        this.emit("login", user);
        return user;
      });
    }
    loginRedirect(host = location.origin) {
      return new Promise((res, rej) => {
        var _a;
        const win = window.open(encodeURI(`${(_a = this.opts) == null ? void 0 : _a.loginUi}?redirect=postmessage&host=${host}`), "_blank");
        if (!win) return rej("Unable to open login");
        const origin = new URL(this.opts.loginUi).origin;
        win.addEventListener("message", (event) => {
          const data = (event == null ? void 0 : event.data) || {};
          if (event.origin != data.sender || data.sender != origin) return;
          if (!data.token) return rej("Unknown response from login");
          this.api.token = event.data.token;
          res(event.data.token);
          win.close();
        });
      });
    }
    logout() {
      this.api.token = null;
      this.user = null;
      this.emit("logout");
    }
    async register(u) {
      var _a;
      const user = await this.api.request({ url: "/api/auth/register", body: { ...u } });
      if ((_a = user == null ? void 0 : user.image) == null ? void 0 : _a.startsWith("/")) user.image = `${this.api.url}${user.image}?token=${this.api.token}`;
      this.emit("register", user);
      return user;
    }
    reset(emailOrPass, token) {
      return this.api.request({
        url: "/api/auth/reset",
        headers: { "Authorization": token ? `Bearer ${token}` : void 0 },
        body: {
          email: token ? void 0 : emailOrPass,
          password: token ? emailOrPass : void 0
        }
      }).then(() => {
        if (token) this.emit("reset", token);
        else this.emit("resetRequest", emailOrPass);
      });
    }
    async session(token, set = false) {
      if (!token) token = this.api.token;
      const session = await this.api.request({
        url: "/api/auth/session",
        headers: token ? { "Authorization": `Bearer ${token}` } : void 0
      });
      if (set) {
        this.api.token = token;
        if (session == null ? void 0 : session.user) session.user.image = `${this.api.url}${session.user.image}?token=${this.api.token}`;
        this.user = (session == null ? void 0 : session.user) || null;
        if (session) this.emit("login", session.user);
      }
      return session;
    }
    async updatePassword(username, password, oldPassword) {
      return this.api.request({
        url: "/api/auth/password",
        body: { username, password, oldPassword }
      }).then((resp) => {
        if (resp == null ? void 0 : resp.token) this.api.token = resp.token;
      });
    }
  }
  class Client {
    constructor(settings) {
      __publicField(this, "_platform");
      __publicField(this, "_pwa");
      this.settings = settings;
    }
    get mobile() {
      return ["android", "ios"].includes(this.platform);
    }
    get platform() {
      if (!this._platform) {
        const userAgent = navigator.userAgent || navigator.vendor;
        if (/windows/i.test(userAgent)) this._platform = "windows";
        else if (/android/i.test(userAgent)) this._platform = "android";
        else if (/iPad|iPhone|iPod/.test(userAgent)) this._platform = "ios";
        else if (/macintosh|mac os x/i.test(userAgent)) this._platform = "mac";
        else if (/linux/i.test(userAgent)) this._platform = "linux";
        else this._platform = "unknown";
      }
      return this._platform;
    }
    get pwa() {
      if (this._pwa == null)
        this._pwa = window.matchMedia("(display-mode: standalone)").matches || (navigator == null ? void 0 : navigator.standalone) || document.referrer.includes("android-app://");
      return this._pwa;
    }
    async inject(reload = false) {
      var _a, _b, _c, _d, _e, _f, _g, _h;
      const settings = await this.settings.all();
      if (!document.querySelector('meta[name="mobile-web-app-capable"]')) {
        const meta = document.createElement("meta");
        meta.name = "mobile-web-app-capable";
        meta.content = "yes";
        document.head.append(meta);
      }
      if (!document.querySelector('meta[name="apple-mobile-web-app-status-bar-style"]')) {
        const meta = document.createElement("meta");
        meta.name = "apple-mobile-web-app-status-bar-style";
        meta.content = "default";
        document.head.append(meta);
      }
      if (!document.querySelector('meta[name="apple-mobile-web-app-title"]')) {
        const meta = document.createElement("meta");
        meta.name = "apple-mobile-web-app-title";
        meta.content = settings["title"];
        document.head.append(meta);
      }
      if (!document.querySelector('link[rel="apple-touch-icon"]')) {
        const meta = document.createElement("link");
        meta.rel = "apple-touch-icon";
        meta.href = settings["logo"];
        document.head.append(meta);
      }
      if (!document.querySelector('link[rel="apple-touch-startup-image"]')) {
        const meta = document.createElement("link");
        meta.rel = "apple-touch-startup-image";
        meta.href = settings["logo"];
        document.head.append(meta);
      }
      window.document.body.classList.add(((_a = settings["theme"]) == null ? void 0 : _a.darkMode) ? "theme-dark" : "theme-light");
      window.document.body.classList.remove(((_b = settings["theme"]) == null ? void 0 : _b.darkMode) ? "theme-light" : "theme-dark");
      if (settings["title"])
        window.document.querySelectorAll(".momentum-title").forEach((el) => el.innerText = settings["title"]);
      if (settings["description"])
        window.document.querySelectorAll(".momentum-description").forEach((el) => el.innerText = settings["description"]);
      if (settings.version)
        window.document.querySelectorAll(".momentum-version").forEach((el) => el.innerText = settings["version"]);
      if (settings["logo"]) {
        window.document.querySelectorAll(".momentum-logo").forEach((el) => {
          el.src = settings["logo"];
          el.href = settings["logo"];
        });
      }
      if (settings["theme"]) {
        let style = window.document.querySelector("#momentum-theme");
        if (!style) {
          style = window.document.createElement("style");
          style.id = "momentum-theme";
          window.document.head.append(style);
        }
        style.innerHTML = `
			:root {
				--theme-bg-primary: ${(_c = settings["theme"]) == null ? void 0 : _c.background};
				--theme-bg-secondary: ${((_d = settings["theme"]) == null ? void 0 : _d.darkMode) ? "#2e2e2e" : "#ffffff"};
				--theme-primary: ${(_e = settings["theme"]) == null ? void 0 : _e.primary};
				--theme-secondary: ${(_f = settings["theme"]) == null ? void 0 : _f.secondary};
				--theme-text: ${((_g = settings["theme"]) == null ? void 0 : _g.darkMode) ? "#ffffff" : "#000000"};
				--theme-muted: ${((_h = settings["theme"]) == null ? void 0 : _h.darkMode) ? "#cccccc" : "#6c757d"};
			}`;
      }
      if (settings["pwa"]) {
        const link = window.document.createElement("link");
        link.setAttribute("rel", "manifest");
        link.setAttribute("href", this.settings.api.url + "/manifest.json");
        window.document.head.append(link);
        setTimeout(() => {
          const dismissed = !!localStorage.getItem("momentum:install-prompt");
          if (!dismissed && !this.pwa && this.mobile) this.pwaPrompt();
        }, 500);
      }
    }
    pwaPrompt(platform) {
      const url = this.settings.api.url;
      const settings = this.settings.cache;
      const android = (platform || this.platform) == "android";
      let style = document.querySelector("style.momentum-pwa");
      if (!style) {
        style = document.createElement("style");
        style.innerHTML = `
		.momentum-pwa-prompt-backdrop {
			position: fixed;
			display: relative;
			left: 0;
			top: 0;
			right: 0;
			bottom: 0;
			background: rgba(0,0,0,.5);
			z-index: 9999;
			animation: fadeIn 0.5s ease-in-out forwards;
			opacity: 0;
		}
		.momentum-pwa-prompt-backdrop.exit {
			animation: fadeOut 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt {
			position: fixed;
			background: #fff;
			color: black;
			bottom: 0;
			left: 50%;
			width: min(100vw, 450px);
			transform: translate(-50%, 0);
			animation: slideUp 0.5s ease-in-out forwards;
		}
		.momentum-pwa-prompt.exit {
			animation: slideDown 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt img {
			width: 18px;
			height: 18px;
		}
		.momentum-pwa-prompt h1 {
			font-size: 1.25rem;
			font-weight: bold;
		}
		.momentum-pwa-prompt-close {
			position: absolute;
			right: 5px;
			top: 10px;
			background: transparent;
			border: none;
			cursor: pointer;
		}

		@keyframes fadeIn {
		  from { opacity: 0; }
		  to { opacity: 1; }
		}
		@keyframes fadeOut {
		  from { opacity: 1; }
		  to { opacity: 0; }
		}

		@keyframes slideUp {
		  from { transform: translate(-50%, 100%); }
		  to { transform: translate(-50%, 0); }
		}
		@keyframes slideDown {
		  from { transform: translate(-50%, 0); }
		  to { transform: translate(-50%, 100%); }
		}
		`;
        document.head.append(style);
      }
      const backdrop = document.createElement("div");
      backdrop.classList.add("momentum-pwa-prompt-backdrop");
      const prompt = document.createElement("div");
      prompt.classList.add("momentum-pwa-prompt");
      prompt.innerHTML = `
			<div style="display: flex; padding: 1rem; align-items: center">
			  <img src="${url}${settings.logo}" alt="Logo" style="height: 30px; width: auto; margin-right: .5rem;" />
			  <h1 style="margin: 0">Install ${settings.title}</h1>
			</div>
			<div style="display: flex; flex-direction: column; align-items: center">
			  <div style="border-top: 2px solid #00000020; border-bottom: 2px solid #00000020; padding: 0 1rem">
				<p style="margin-top: 1rem; text-align: center">This website can be installed as an App! Add it to your home screen for quick access & fullscreen use.</p>
			  </div>
			  <table style="margin: 1.5rem 0">
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(1.5)"><path d="M480-160q-33 0-56.5-23.5T400-240q0-33 23.5-56.5T480-320q33 0 56.5 23.5T560-240q0 33-23.5 56.5T480-160Zm0-240q-33 0-56.5-23.5T400-480q0-33 23.5-56.5T480-560q33 0 56.5 23.5T560-480q0 33-23.5 56.5T480-400Zm0-240q-33 0-56.5-23.5T400-720q0-33 23.5-56.5T480-800q33 0 56.5 23.5T560-720q0 33-23.5 56.5T480-640Z"/></svg>' : '<svg viewBox="0 0 566 670" xmlns="http://www.w3.org/2000/svg" fill="#0B76FC" height="40px"><path d="M255 12c4-4 10-8 16-8s12 3 16 8l94 89c3 4 6 7 8 12 2 6 0 14-5 19-7 8-20 9-28 2l-7-7-57-60 2 54v276c0 12-10 22-22 22-12 1-24-10-23-22V110l1-43-60 65c-5 5-13 8-21 6a19 19 0 0 1-16-17c-1-7 2-13 7-18l95-91z" /><path d="M43 207c16-17 40-23 63-23h83v46h-79c-12 0-25 3-33 13-8 9-10 21-10 33v260c0 13 0 27 6 38 5 12 18 18 30 19l14 1h302c14 0 28 0 40-8 11-7 16-21 16-34V276c0-11-2-24-9-33-8-10-22-13-34-13h-78v-46h75c13 0 25 1 37 4 16 4 31 13 41 27 11 17 14 37 14 57v280c0 20-3 41-15 58a71 71 0 0 1-45 27c-11 2-23 3-34 3H109c-19-1-40-4-56-15-14-9-23-23-27-38-4-12-5-25-5-38V270c1-22 6-47 22-63z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">1) ${android ? "Open the dropdown menu" : 'Press the "Share" button'}</p>
				  </td>
				</tr>
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(-1.5, 1.5)"><path d="M280-40q-33 0-56.5-23.5T200-120v-720q0-33 23.5-56.5T280-920h280v80H280v40h280v80H280v480h400v-80h80v200q0 33-23.5 56.5T680-40H280Zm0-120v40h400v-40H280Zm440-240L520-600l56-56 104 104v-288h80v288l104-104 56 56-200 200ZM280-800v-40 40Zm0 640v40-40Z"/></svg>' : '<svg viewBox="0 0 578 584" xmlns="http://www.w3.org/2000/svg" fill="black" height="34px"><path d="M101 35l19-1h333c12 0 23 0 35 3 17 3 34 12 44 27 13 16 16 38 16 58v329c0 19 0 39-8 57a65 65 0 0 1-37 37c-18 7-38 7-57 7H130c-21 1-44 0-63-10-14-7-25-20-30-34-6-15-8-30-8-45V121c1-21 5-44 19-61 13-16 33-23 53-25m7 46c-10 1-19 6-24 14-7 8-9 20-9 31v334c0 12 2 25 10 34 9 10 23 12 35 12h336c14 1 30-3 38-15 6-9 8-20 8-31V125c0-12-2-24-10-33-9-9-22-12-35-12H121l-13 1z" /><path d="M271 161c9-11 31-10 38 4 3 5 3 11 3 17v87h88c7 0 16 1 21 7 6 6 7 14 6 22a21 21 0 0 1-10 14c-5 4-11 5-17 5h-88v82c0 7-1 15-6 20-10 10-29 10-37-2-3-6-4-13-4-19v-81h-87c-8-1-17-3-23-9-5-6-6-15-4-22a21 21 0 0 1 11-14c6-3 13-3 19-3h84v-88c0-7 1-14 6-20z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">2) Press "Add to Home Screen"</p>
				  </td>
				</tr>
			  </table>
			</div>`;
      const close = document.createElement("button");
      close.classList.add("momentum-pwa-prompt-close");
      close.innerText = "X";
      close.onclick = () => {
        prompt.classList.add("exit");
        backdrop.classList.add("exit");
        localStorage.setItem("momentum:install-prompt", "dismissed");
        setTimeout(() => {
          prompt.remove();
          backdrop.remove();
        }, 500);
      };
      prompt.append(close);
      backdrop.append(prompt);
      document.body.append(backdrop);
    }
  }
  class Data extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    create(collection, document2) {
      return this.api.request({
        url: `/api/data/${collection.replaceAll(/(^\/|\/$)/g, "")}`,
        method: "POST",
        body: document2
      }).then((resp) => {
        this.emit("create", collection, resp);
        return resp;
      });
    }
    read(collection, id) {
      return this.api.request({ url: `/api/data/${collection.replaceAll(/(^\/|\/$)/g, "")}/${id ?? ""}` }).then((resp) => {
        this.emit("read", collection, resp);
        return resp;
      });
    }
    update(collection, document2, append = true) {
      if (!document2._id) return this.create(collection, document2);
      return this.api.request({
        url: `/api/data/${collection.replaceAll(/(^\/|\/$)/g, "")}/${document2._id}`,
        method: append ? "PATCH" : "PUT",
        body: document2
      }).then((resp) => {
        this.emit("update", collection, resp);
        return resp;
      });
    }
    delete(collection, id) {
      return this.api.request({
        url: `/api/data/${collection.replaceAll(/(^\/|\/$)/g, "")}/${id}`,
        method: "DELETE"
      }).then(() => this.emit("delete", collection, id));
    }
    raw(collection, query) {
      return this.api.request({ url: `/api/data/${collection.replaceAll(/(^\/|\/$)/g, "")}`, body: query }).then((resp) => {
        this.emit("raw", collection, query, resp);
        return resp;
      });
    }
    deleteSchema(collection) {
      return this.api.request({ url: `/api/data/schema/${collection.replaceAll(/(^\/|\/$)/g, "")}`, method: "DELETE" });
    }
    getSchema(pathOrTree) {
      let url = "/api/data/schema";
      if (typeof pathOrTree == "string") url += `/${pathOrTree.replaceAll(/(^\/|\/$)/g, "")}`;
      else if (typeof pathOrTree == "boolean") url += `?tree=${pathOrTree}`;
      return this.api.request({ url });
    }
    setSchema(schema) {
      return this.api.request({ url: `/api/data/schema/${schema.path.replaceAll(/(^\/|\/$)/g, "")}`, body: schema });
    }
  }
  class Email extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    send(email) {
      let url = "/api/email";
      if (typeof email.body == "object") url += `/${email.body.template}`;
      return this.api.request({ url, body: email }).then((resp) => {
        this.emit("sent", email, resp);
        return resp;
      });
    }
  }
  class Groups extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    all() {
      return this.api.request({ url: `/api/groups` }).then((resp) => {
        this.emit("all", resp || []);
        return resp;
      });
    }
    create(group) {
      return this.api.request({
        url: `/api/groups/${group.name}`,
        method: "POST",
        body: group
      }).then((resp) => {
        this.emit("create", resp);
        return resp;
      });
    }
    read(name) {
      return this.api.request({ url: `/api/groups/${name}` }).then((resp) => {
        this.emit("read", resp);
        return resp;
      });
    }
    update(group) {
      return this.api.request({
        url: `/api/groups/${group.name}`,
        method: "PATCH",
        body: group
      }).then((resp) => {
        this.emit("update", resp);
        return resp;
      });
    }
    delete(name) {
      return this.api.request({
        url: `/api/groups/${name}`,
        method: "DELETE"
      }).then(() => this.emit("delete", name));
    }
  }
  class Logger {
    constructor(api, logLevel) {
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
      if (logLevel != null && logLevel != "NONE") {
        window.addEventListener("error", (event) => {
          var _a, _b;
          return this.error(((_a = event.error) == null ? void 0 : _a.stack) || ((_b = event.error) == null ? void 0 : _b.message) || event.error);
        });
        window.addEventListener("unhandledrejection", async (event) => {
          var _a, _b, _c, _d;
          let log = ((_a = event.reason) == null ? void 0 : _a.stack) || event.reason;
          if ((_b = event.reason) == null ? void 0 : _b.url)
            log = `${event.reason.method} ${event.reason.url} -> ${event.reason.code}

${log}`;
          ((_c = event.reason) == null ? void 0 : _c.code) == null || ((_d = event.reason) == null ? void 0 : _d.code) >= 500 ? this.error(log) : this.warn(log);
        });
      }
    }
    buildLog(level, log) {
      return {
        time: (/* @__PURE__ */ new Date()).getTime(),
        level,
        log,
        ctx: {
          cores: navigator.hardwareConcurrency,
          mem: navigator == null ? void 0 : navigator.deviceMemory,
          res: [window.innerWidth, window.innerHeight],
          url: location.href
        }
      };
    }
    clearClientLogs() {
      return this.api.request({ url: `/api/logs/client`, method: "DELETE" });
    }
    clearServerLogs() {
      return this.api.request({ url: `/api/logs/server`, method: "DELETE" });
    }
    clientLogs(length, page) {
      const query = [length ? `length=${length}` : void 0, page ? `page=${page}` : void 0].filter((v) => !!v).join("&");
      return this.api.request({ url: `/api/logs/client${query ? `?${query}` : ""}` }).then((resp) => resp);
    }
    serverLogs(length, page) {
      const query = [length ? `length=${length}` : void 0, page ? `page=${page}` : void 0].filter((v) => !!v).join("&");
      return this.api.request({ url: `/api/logs/server${query ? `?${query}` : ""}` }).then((resp) => resp);
    }
    debug(...logs) {
      return this.api.request({ url: `/api/logs/client`, body: this.buildLog(yt.DEBUG, logs) }).then(() => {
      }).catch(() => {
      });
    }
    log(...logs) {
      return this.api.request({ url: `/api/logs/client`, body: this.buildLog(yt.LOG, logs) }).then(() => {
      }).catch(() => {
      });
    }
    info(...logs) {
      return this.api.request({ url: `/api/logs/client`, body: this.buildLog(yt.INFO, logs) }).then(() => {
      }).catch(() => {
      });
    }
    warn(...logs) {
      return this.api.request({ url: `/api/logs/client`, body: this.buildLog(yt.WARN, logs) }).then(() => {
      }).catch(() => {
      });
    }
    error(...logs) {
      return this.api.request({ url: `/api/logs/client`, body: this.buildLog(yt.ERROR, logs) }).then(() => {
      }).catch(() => {
      });
    }
  }
  class Payments extends _ {
    constructor(api, secret) {
      super();
      __publicField(this, "api");
      __publicField(this, "stripe");
      this.api = typeof api == "string" ? new Api(api) : api;
      const setup = (retry = 1) => {
        try {
          if (!Stripe) throw new Error("Stripe not added");
          this.stripe = Stripe(secret);
        } catch (err) {
          if (retry > 0) setTimeout(() => setup(retry--), 250);
          else console.warn("Stripe failed, did you add the library & setup your API key?", err);
        }
      };
      setup();
    }
    async create(amount, custom = {}) {
      const request = await this.api.request({ url: "/api/payments", body: {
        amount,
        custom
      } });
      this.emit("create", amount, custom, request.data.clientSecret);
      return request.data.clientSecret;
    }
    async createForm(element, amount, custom) {
      const token = await this.create(amount, custom);
      const form = this.stripe.elements({ clientSecret: token });
      form.create("payment").mount(element);
      return () => this.stripe.confirmPayment({
        elements: form,
        redirect: "if_required",
        confirmParams: { return_url: location.origin }
      });
    }
    async history(username) {
      const history = await this.api.request({ url: `/api/payments${username ? `/${username}` : ""}` });
      this.emit("history", username || null, history);
      return history;
    }
  }
  class Pdf extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    async handleResponse(resp, fileName) {
      const blob = await resp.blob();
      if (fileName) {
        const url = URL.createObjectURL(blob);
        dt(url, fileName.endsWith(".pdf") ? fileName : fileName + ".pdf");
        URL.revokeObjectURL(url);
      }
      this.emit("create", blob);
      return blob;
    }
    fromHtml(content, opts = {}) {
      return this.api.request({ url: `/api/pdf`, body: { html: content }, decode: false }).then((resp) => this.handleResponse(resp, opts.download ? opts.fileName || (/* @__PURE__ */ new Date()).toISOString() : void 0));
    }
    fromTemplate(template, data, opts = {}) {
      return this.api.request({ url: `/api/pdf${template}`, body: data, decode: false }).then((resp) => this.handleResponse(resp, opts.download ? opts.fileName || (/* @__PURE__ */ new Date()).toISOString() : void 0));
    }
    fromUrl(url, opts = {}) {
      return this.api.request({ url: `/api/pdf`, body: { url }, decode: false }).then((resp) => this.handleResponse(resp, opts.download ? opts.fileName || (/* @__PURE__ */ new Date()).toISOString() : void 0));
    }
  }
  const _Socket = class _Socket {
    constructor(api) {
      __publicField(this, "api");
      __publicField(this, "url");
      __publicField(this, "connection");
      __publicField(this, "open", false);
      this.api = typeof api == "string" ? new Api(api) : api;
      this.url = this.api.url.replace("http", "ws");
      this.api.on("token", () => this.connect());
      this.connect();
    }
    close() {
      console.debug("Disconnected from Momentum");
      this.open = false;
      this.connection.close();
    }
    connect(retry = 3) {
      var _a;
      if (((_a = this.connection) == null ? void 0 : _a.readyState) < 2) this.connection.close();
      this.connection = new WebSocket(this.url + (this.api.token ? `?token=${this.api.token}` : ""));
      const timeout = setTimeout(() => {
        if (this.open) return;
        this.connection.close();
        console.error(`Momentum connection timeout`);
        if (retry > 0) this.connect(retry - 1);
      }, _Socket.timeout);
      this.connection.onclose = () => this.open = false;
      this.connection.onmessage = this.handle;
      this.connection.onopen = () => {
        this.open = true;
        clearTimeout(timeout);
        console.debug("Connected to Momentum");
      };
    }
    handle(...args) {
      console.log(args);
    }
    send(channel, payload) {
      this.connection.send(JSON.stringify({
        token: this.api.token,
        channel,
        payload
      }));
    }
  };
  __publicField(_Socket, "timeout", 1e4);
  let Socket = _Socket;
  class Storage extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    copy(path) {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      return this.api.request({ url, method: "PUT" }).then((resp) => {
        this.emit("copy", path, resp);
        return resp;
      });
    }
    delete(path) {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      return this.api.request({ url, method: "DELETE" }).then(() => {
        this.emit("delete", url);
      });
    }
    download(path, opts = {}) {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      return this.api.request({ ...opts, url, decode: false }).then(async (response) => {
        const blob = await response.blob();
        const name = opts.downloadAs || path.split("/").pop();
        this.emit("download", path, blob);
        Gt(blob, name);
        return response;
      });
    }
    list(path) {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      return this.api.request({ url: url + "?list" }).then((resp) => {
        this.emit("list", path, resp);
        return resp;
      });
    }
    open(path, target = "_blank") {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      const link = `${this.api.url}${url}${this.api.token ? `?token=${this.api.token}` : ""}`;
      if (!target) return link;
      this.emit("open", path);
      return window.open(link, target);
    }
    mkdir(path) {
      const url = this.api.path(path.startsWith("/api/storage/") ? "" : "/api/storage/", path);
      return this.api.request({ url: url + "?directory", method: "POST" }).then((resp) => {
        this.emit("mkdir", path, resp);
        return resp;
      });
    }
    move(from, to) {
      if (from == to) return this.list(to);
      const url = this.api.path(from.startsWith("/api/storage/") ? "" : "/api/storage/", from);
      return this.api.request({ url, method: "PATCH", body: { move: to } }).then((resp) => {
        this.emit("move", from, to, resp);
        return resp;
      });
    }
    upload(files, opts = "") {
      return new E(async (res, rej, prog) => {
        if (!files) files = await Ut(typeof opts == "object" ? opts : void 0);
        if (!files || Array.isArray(files) && !files.length) return [];
        const path = this.api.path("/api/storage/", typeof opts == "string" ? opts : opts.path || "");
        return Ft({
          url: `${this.api.url}${path}`,
          files: ft(files),
          headers: this.api.headers
        }).onProgress((p2) => {
          prog(p2);
        }).then((resp) => {
          this.emit("upload", resp);
          res(resp);
        }).catch((err) => rej(err));
      });
    }
  }
  class Users extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "listed", false);
      __publicField(this, "cache", new Dt("username"));
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    delete(username) {
      return this.api.request({
        url: `/api/users/${username}`,
        method: "DELETE"
      }).then(() => {
        this.cache.delete(username);
        this.emit("delete", username);
      });
    }
    async all(reload = false) {
      if (!reload && this.cache.complete) return this.cache.all();
      return this.api.request({ url: `/api/users` }).then((resp) => {
        resp == null ? void 0 : resp.forEach((r) => {
          r.image = this.api.url + r.image + `?token=${this.api.token}`;
          return r;
        });
        this.cache.addAll(resp);
        this.listed = true;
        this.emit("all", resp || []);
        return resp;
      });
    }
    async read(username, reload = false) {
      if (!reload && this.cache.get(username)) return this.cache.get(username);
      return this.api.request({ url: `/api/users/${username}` }).then((resp) => {
        if (resp) {
          resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
          this.cache.add(resp);
        }
        this.emit("read", resp);
        return resp;
      });
    }
    update(user) {
      return this.api.request({
        url: `/api/users/${user.username}`,
        method: "PATCH",
        body: user
      }).then((resp) => {
        if (resp) {
          resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
          this.cache.add(resp);
        }
        this.emit(resp._id ? "update" : "create", resp);
        return resp;
      });
    }
    uploadImage(username, file) {
      return Ft({
        url: this.api.url + `/api/users/${username}/image`,
        files: [file],
        headers: this.api.headers
      }).then((resp) => {
        this.emit("image", username, file);
        return resp;
      });
    }
  }
  class Settings extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Dt());
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    async all(detailed = false, reload) {
      if (!reload && !detailed && this.cache.complete) return this.cache;
      return this.api.request({ url: `/api/settings` + (detailed ? "?detailed" : "") }).then((resp) => {
        Object.entries(resp).forEach(([key, value]) => this.cache.set(key, detailed ? value.value : value));
        this.cache.complete = true;
        this.emit("all", resp || []);
        return resp;
      });
    }
    delete(key) {
      return this.api.request({ url: `/api/settings/${key}`, method: "DELETE" }).then(() => {
        this.cache.delete(key);
        this.emit("delete", key);
      });
    }
    read(key, reload = false) {
      if (!reload && this.cache.get(key)) return this.cache.get(key);
      return this.api.request({ url: `/api/settings/${key}` }).then((variable) => {
        if (variable) this.cache.set(variable.key, variable.value);
        this.emit("read", variable);
        return variable;
      });
    }
    update(variable) {
      return this.api.request({ url: `/api/settings/${variable.key}`, body: variable }).then((variable2) => {
        if (variable2) this.cache.set(variable2.key, variable2.value);
        this.emit("update", variable2);
        return variable2;
      });
    }
  }
  class Static extends _ {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    delete(path) {
      return this.api.request({ url: `/api/static/${path}`, method: "DELETE" }).then(() => {
        this.emit("delete", path);
      });
    }
    upload(files, path = "/") {
      return new E(async (res, rej, prog) => {
        return Ft({
          url: this.api.url + ("/api/static/" + path).replaceAll("//", "/"),
          files: ft(files),
          headers: this.api.headers
        }).onProgress((p2) => {
          prog(p2);
        }).then((resp) => {
          this.emit("upload", resp);
          res(resp);
        }).catch((err) => rej(err));
      });
    }
  }
  class Momentum extends _ {
    constructor(url, opts) {
      super();
      __publicField(this, "api");
      __publicField(this, "actions");
      __publicField(this, "ai");
      __publicField(this, "analytics");
      __publicField(this, "auth");
      __publicField(this, "client");
      __publicField(this, "data");
      __publicField(this, "email");
      __publicField(this, "groups");
      __publicField(this, "logger");
      __publicField(this, "payments");
      __publicField(this, "pdf");
      __publicField(this, "settings");
      __publicField(this, "socket");
      __publicField(this, "static");
      __publicField(this, "storage");
      __publicField(this, "users");
      this.api = new Api(url, opts == null ? void 0 : opts.api);
      this.actions = new Actions(this.api);
      this.ai = new Ai(this.api);
      this.analytics = new Analytics(this.api);
      this.auth = new Auth(this.api, {
        persist: (opts == null ? void 0 : opts.persist) ?? true,
        loginUi: opts == null ? void 0 : opts.loginUi
      });
      this.data = new Data(this.api);
      this.email = new Email(this.api);
      this.groups = new Groups(this.api);
      this.logger = new Logger(this.api, opts == null ? void 0 : opts.logLevel);
      if (opts == null ? void 0 : opts.stripeSecret) this.payments = new Payments(this.api, opts.stripeSecret);
      this.pdf = new Pdf(this.api);
      this.settings = new Settings(this.api);
      if (opts == null ? void 0 : opts.socket) this.socket = new Socket(this.api);
      this.static = new Static(this.api);
      this.storage = new Storage(this.api);
      this.client = new Client(this.settings);
      this.users = new Users(this.api);
      this.api.on("*", (event, ...args) => this.emit(`Api:${event}`, ...args));
      this.actions.on("*", (event, ...args) => this.emit(`Actions:${event}`, ...args));
      this.auth.on("*", (event, ...args) => this.emit(`Auth:${event}`, ...args));
      this.data.on("*", (event, ...args) => this.emit(`Data:${event}`, ...args));
      this.email.on("*", (event, ...args) => this.emit(`Email:${event}`, ...args));
      this.groups.on("*", (event, ...args) => this.emit(`Groups:${event}`, ...args));
      if (this.payments) this.payments.on("*", (event, ...args) => this.emit(`Payments:${event}`, ...args));
      this.pdf.on("*", (event, ...args) => this.emit(`Pdf:${event}`, ...args));
      this.settings.on("*", (event, ...args) => this.emit(`Settings:${event}`, ...args));
      this.static.on("*", (event, ...args) => this.emit(`Static:${event}`, ...args));
      this.storage.on("*", (event, ...args) => this.emit(`Storage:${event}`, ...args));
      this.users.on("*", (event, ...args) => this.emit(`Users:${event}`, ...args));
      this.users.on("*", (event, ...args) => {
        const u = ft(args[0]).find((u2) => {
          var _a;
          return (u2 == null ? void 0 : u2._id) == ((_a = this.auth.user) == null ? void 0 : _a._id);
        });
        if (u) this.auth.user = u;
      });
    }
  }
  exports2.ActionType = ActionType;
  exports2.Actions = Actions;
  exports2.Ai = Ai;
  exports2.Analytics = Analytics;
  exports2.Api = Api;
  exports2.Auth = Auth;
  exports2.Client = Client;
  exports2.Data = Data;
  exports2.Email = Email;
  exports2.Groups = Groups;
  exports2.Logger = Logger;
  exports2.Momentum = Momentum;
  exports2.Payments = Payments;
  exports2.Pdf = Pdf;
  exports2.Settings = Settings;
  exports2.Socket = Socket;
  exports2.Static = Static;
  exports2.Storage = Storage;
  exports2.Totp = Totp;
  exports2.Users = Users;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
